--Programm für ESP8266
--AP Modus 
--
print('Server start')
wifi.setmode(wifi.SOFTAP)     --Setze Mode für eigene Station
cfg={}
cfg.ssid="ESP8266"
cfg.pwd="12345678"
wifi.ap.config(cfg)    --Net initialisieren
print('ip: ',wifi.ap.getip())
led1 = 0                       --LED1 ist GPIO 0
led2 = 2                       --LED2 ist GPIO 14
laenge=0
gpio.mode(led1, gpio.OUTPUT)   --LED1 ist Ausgang
gpio.mode(led2, gpio.OUTPUT)   --LED2 ist Ausgang
srv=net.createServer(net.TCP)  --
srv:listen(80,function(conn)   --Port 80 setzen
    conn:on("receive", function(client,request)
        local buf = "";
        local _, _, method, path, vars = string.find(request, "([A-Z]+) (.+)?(.+) HTTP");
        if(method == nil)then
            _, _, method, path = string.find(request, "([A-Z]+) (.+) HTTP");
        end
        local _GET = {}
        if (vars ~= nil)then
            for k, v in string.gmatch(vars, "(%w+)=(%w+)&*") do
                _GET[k] = v
            end
        end
        
        --Die Web seite
        buf = buf.."<h1>ESP8266<br><br></h1>";
        buf = buf.."<p><h1>AUSGANG 1&nbsp;&nbsp;<a href=\"?pin=ON1\"><button>ON</button></a>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"?pin=OFF1\"><button>OFF</button></a></p></h1>";
        buf = buf.."<p><h1>AUSGANG 2&nbsp;&nbsp;<a href=\"?pin=ON2\"><button>ON</button></a>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"?pin=OFF2\"><button>OFF</button></a></p></h1>";
        buf = buf.."<p><br><br><u>Aktueller Zustand: </u><br></p>";
        local _on,_off = "",""
        if(_GET.pin == "ON1")then
              gpio.write(led1, gpio.HIGH);
              laenge=laenge+1
              print('1 = ON ')
        elseif(_GET.pin == "OFF1")then
              gpio.write(led1, gpio.LOW);
              print('1 = OFF ')
        elseif(_GET.pin == "ON2")then
              gpio.write(led2, gpio.HIGH);
              print('2 = ON ')
        elseif(_GET.pin == "OFF2")then
              gpio.write(led2, gpio.LOW);
              print('2 = OFF ')
        end
        
        --Ausgang 1 ausgeben
        value = gpio.read(0)
        if value == gpio.LOW then
           buf = buf.."<p><b>AUSGANG 1 = OFF</b></p>";
        else
           buf = buf.."<p><b>AUSGANG 1 = ON</b></p>";
        end
        
        --Ausgang2 ausgeben
        value = gpio.read(2)
        if value == gpio.LOW then
           buf = buf.."<p><b>AUSGANG 2 = OFF</b></p>";
        else
           buf = buf.."<p><b>AUSGANG 2 = ON</b></p>";
        end
        buf=buf.."<p><b>Laenge = </b></p>",laenge;
        client:send(buf);
        client:close();
        collectgarbage();
    end)
end)
